#!/usr/bin/perl
# Linux$BB&%U%!%$%k$G(BWindows$B$+$i(BSamba$B7PM3$G;2>H$9$k$HIT6q9g$,=P$k%U%!%$%kL>$r(B
# $BLdBj$,H/@8$7$J$$%U%!%$%kL>$KCV$-49$($k(B

use Getopt::Std;

getopts('x');

$BaseDir = $ARGV[0];

# $B%U%!%$%kL>CV$-49$(J8;z%j%9%H(B
%ReplaceList = ("\xe3\x80\x9c" => "\xef\xbd\x9e", # $B!A(B
		"\xe2\x88\x92" => "\xef\xbc\x8d"  # $B!](B
		);

ReplaceLetter($BaseDir);

sub ReplaceLetter {

    my $Dir = shift;
    my $File;

    my $OldName, $NewName;
    my $DIR;
    my $Match;

    #printf "$Dir\n";
    opendir($DIR, $Dir) or die("Can not open directory:$Dir ($!)");
    while( $File = readdir($DIR) ) {
	# '.' $B$H(B '..' $B$O%Q%9(B
        next if( $File =~ /^\.{1,2}$/ );        

        # $B%G%#%l%/%H%j$N>l9g$O<+J,<+?H$r8F$S=P$9(B
        if( -d "$Dir/$File" ){
            ReplaceLetter("$Dir/$File");
        } else {
	    # $BCV$-49$(BP>]$+$I$&$+D4$Y$k(B
	    $OldName = $File;
	    $NewName = ReplaceCheck($OldName);
	    # $BCV$-49$($,I,MW!J?7L>$H5lL>$,0c$&!K$J$i%j%M!<%`(B
	    if($NewName ne $OldName) {
		$OldName = $Dir."/".$OldName;
		$NewName = $Dir."/".$NewName;
		printf "f [%s]\n  -> [%s]", $OldName, $NewName;
		if($opt_x) {
		    print "\n";
		    rename $OldName, $NewName || die "Can't rename file ($!)\n";
		} else {
		    print " <Test>\n";
		}
	    }
	}
    }
    closedir($DIR);

    # $BCV$-49$(BP>]$+$I$&$+D4$Y$k(B
    $OldName = $Dir;
    $NewName = ReplaceCheck($OldName);
    # $BCV$-49$($,I,MW!J?7L>$H5lL>$,0c$&!K$J$i%j%M!<%`(B
    if($NewName ne $OldName) {
	printf "d [%s]\n  -> [%s]", $OldName, $NewName;
	if($opt_x) {
	    print "\n";
	    rename $OldName, $NewName || die "Can't rename directory ($!)\n";
	} else {
	    print " <Test>\n";
	}
    }
}

# $BCV$-49$(BP>]%A%'%C%/(B
sub ReplaceCheck {
    my ($Name) = @_;
    my ($Key);
    # $BCV$-49$(%j%9%H$N%(%s%H%j$H0lCW$9$l$PCV$-49$(<B9T(B
    foreach $Key (keys(%ReplaceList)) {
	if($Name =~ /$Key/) {
	    $Name =~ s/$Key/$ReplaceList{$Key}/g;
	}
    }

    return $Name;
}
